HDU 1011(树形DP)

24 篇文章 0 订阅

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 21216    Accepted Submission(s): 5652


Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.
 

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.
 

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.
 

Sample Input
 
 
5 10 50 10 40 10 40 20 65 30 70 30 1 2 1 3 2 4 2 5 1 1 20 7 -1 -1
 

Sample Output
 
 
50 7
 

Author
XU, Chuan
 

Source
 

Recommend
JGShining
 

题目大意:有n个位置形成的树,每个位置有很多BUG,每20BUG可用一个士兵解决,每个位置有一个概率,现在有m个士兵获得最大概率是多少

解题思路:这道题是一个树形dp,首先暂时不考虑树形,本身的这道题是内在是一个01背包问题带上一个树,所以转移方程是dp[i][j]=max(dp[i][j],dp[i][j-u]+dp[k][u]表示的是在i这个位置已经占用j人获得最大的概率

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cstdlib>
#include <ctime>
using namespace std;
typedef long long LL;

int n,m;
struct point
{
	int hope,bug;
}a[105];
int dp[105][105];
int check[105];
vector<int> tu[105];
void dfs(int son,int fa)
{
	int i,j,u,k;
	for(i=a[son].bug;i<=m;i++)
		dp[son][i]=a[son].hope;
	for(i=0;i<tu[son].size();i++)
	{
		k=tu[son][i];
		if(k == fa)
			continue;
		dfs(k,son);
		for(j=m;j>=a[son].bug;j--)
		{
			for(u=1;u<=j-a[son].bug;u++)
				dp[son][j]=max(dp[son][j],dp[son][j-u]+dp[k][u]);
		}

	}
}
int main()
{
	int i,x,y;
	while(cin>>n>>m)
	{
		memset(tu,0,sizeof(tu));
		memset(check,0,sizeof(check));
		memset(dp,0,sizeof(dp));
		if(n==-1&&m==-1)
			break;
		for(i=1;i<=n;i++)
		{
			cin>>a[i].bug>>a[i].hope;
			a[i].bug = (a[i].bug + 19)/20;
		}
	
		for(i=1;i<n;i++)
		{
			cin>>x>>y;
			tu[x].push_back(y);
			tu[y].push_back(x);
		}
		if(m==0)
		{
			cout<<0<<endl;
			continue;
		}
		dfs(1,0);
		cout<<dp[1][m]<<endl;
	}
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值